3 # Copyright (c) 2006 - 2007 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
40 # If there is no useful db support compile in, disable test
41 ..
/db
/have-db ||
exit 77
47 keytabfile
=${objdir}/server.keytab
48 keytab
="FILE:${keytabfile}"
49 cache
="FILE:krb5ccfile"
50 cacheds
="FILE:krb5ccfile-ds"
52 kinit
="${TESTS_ENVIRONMENT} ../../kuser/kinit -c $cache --no-afslog"
53 kinitds
="${TESTS_ENVIRONMENT} ../../kuser/kinit -c $cacheds --no-afslog"
54 kadmin
="${TESTS_ENVIRONMENT} ../../kadmin/kadmin -l -r $R"
55 kdc
="${TESTS_ENVIRONMENT} ../../kdc/kdc --addresses=localhost -P $port"
56 kdigest
="${TESTS_ENVIRONMENT} ../../kuser/kdigest"
58 context
="${TESTS_ENVIRONMENT} ../../lib/gssapi/test_context"
60 KRB5_CONFIG
="${objdir}/krb5.conf"
63 KRB5_KTNAME
="${keytab}"
67 NTLM_ACCEPTOR_CCACHE
="${cacheds}"
68 export NTLM_ACCEPTOR_CCACHE
69 NTLM_USER_FILE
="${srcdir}/ntlm-user-file.txt"
72 GSSAPI_SPNEGO_NAME
=host@
host.
test.h5l.se
73 export GSSAPI_SPNEGO_NAME
82 echo Creating database
85 --realm-max-ticket-life=1day \
86 --realm-max-renewable-life=1month \
89 ${kadmin} add
-p p1
--use-defaults host
/host.
test.h5l.se@
${R} ||
exit 1
90 ${kadmin} ext -k ${keytab} host/host.test.h5l.se@${R} ||
exit 1
92 ${kadmin} add -p kaka --use-defaults digest/${R}@${R} ||
exit 1
94 ${kadmin} add
-p ds
--use-defaults digestserver@
${R} ||
exit 1
95 ${kadmin} modify
--attributes=+allow-digest digestserver@
${R} ||
exit 1
97 ${kadmin} add
-p u1
--use-defaults user1@
${R} ||
exit 1
99 echo "Doing database check"
100 ${kadmin} check
${R} ||
exit 1
102 echo u1
> ${objdir}/foopassword
103 echo ds
> ${objdir}/barpassword
109 sh
${srcdir}/..
/kdc
/wait-kdc.sh
110 if [ "$?" != 0 ] ; then
115 trap "kill ${kdcpid}; echo signal killing kdc; exit 1;" EXIT
119 echo "Getting client initial tickets"
120 ${kinit} --password-file=${objdir}/foopassword user1@${R} || exitcode
=1
121 echo "Getting digestserver initial tickets"
122 ${kinitds} --password-file=${objdir}/barpassword digestserver@${R} || exitcode
=1
125 KRB5CCNAME
="$cacheds"
127 ${kdigest} digest-probe
--realm=${R} > /dev
/null || \
128 { exitcode
=1; echo "test failed"; }
130 echo "======context building ntlm"
132 NTLM_USER_FILE
="${srcdir}/ntlm-user-file.txt-no"
135 echo "no NTLM initiator creds"
136 ${context} --mech-type=ntlm \
138 --name-type=hostbased-service \
139 --ret-mech-type=ntlm \
140 host@
host.
test.h5l.se
2> /dev
/null
&& \
141 { exitcode
=1 ; echo "test failed"; }
143 echo "Getting client initial tickets (with ntlm creds)"
144 ${kinit} --password-file=${objdir}/foopassword --ntlm-domain=TEST user1@${R} || exitcode
=1
146 echo "NTLM initiator krb5 creds"
147 ${context} --mech-type=ntlm \
149 --name-type=hostbased-service \
150 --ret-mech-type=ntlm \
151 host@
host.
test.h5l.se || \
152 { exitcode
=1 ; echo "test failed"; }
154 echo "NTLM initiator krb5 creds (getverifymic, wrapunwrap)"
155 ${context} --mech-type=ntlm \
157 --name-type=hostbased-service \
158 --ret-mech-type=ntlm \
159 --getverifymic --wrapunwrap \
160 host@
host.
test.h5l.se || \
161 { exitcode
=1 ; echo "test failed"; }
165 echo "killing kdc (${kdcpid})"
166 kill ${kdcpid} 2> /dev
/null